SystemOrganization addCategory: #'Athens-Cairo'!
SystemOrganization addCategory: #'Athens-Cairo-Paths'!
SystemOrganization addCategory: #'Athens-Cairo-Paths-Tests'!

Trait named: #TCairoLibrary
	uses: {}
	category: 'Athens-Cairo'!

!TCairoLibrary classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 16:53'!
nbLibraryNameOrHandle
	^ '/opt/local/lib/libcairo.2.dylib'! !

!TCairoLibrary methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 16:52'!
nbLibraryNameOrHandle
	^ self class nbLibraryNameOrHandle
! !

Trait named: #TCairoPaint
	uses: {}
	category: 'Athens-Cairo'!

!TCairoPaint methodsFor: 'drawing' stamp: 'IgorStasenko 3/8/2012 17:34'!
fillPath: path on: anAthensCanvas 
	self loadOn: anAthensCanvas.
	anAthensCanvas loadPath: path.
	self fillOn: anAthensCanvas.	
! !

!TCairoPaint methodsFor: 'drawing' stamp: 'FernandoOlivero 1/25/2012 00:09'!
fillRectangle: aRect on: anAthensCanvas
	"This is a terminal method in rendering dispatch scheme
	canvas->shape->paint. See AthensCanvas>>fillShape: "
	self loadOn: anAthensCanvas at: aRect origin.
	anAthensCanvas
		rectangleX: aRect left
		y: aRect top
		width: aRect width
		height: aRect height.
	self fillOn: anAthensCanvas.	
! !

!TCairoPaint methodsFor: 'drawing' stamp: 'FernandoOlivero 1/25/2012 00:09'!
loadOn: anAthensCanvas at: aPoint
	self loadOn: anAthensCanvas ! !

NBExternalStructure variableByteSubclass: #SQSurfaceDispatch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo'!

!SQSurfaceDispatch commentStamp: 'IgorStasenko 12/30/2011 12:35' prior: 0!
A structure from SurfacePlugin.h 
 

typedef struct sqSurfaceDispatch {
	/* Version information. Must be provided by the client
	   so the surface manager can check if certain operations
	   are supported. */
	int majorVersion;
	int minorVersion;

	/* Version 1.0 */
	fn_getSurfaceFormat getSurfaceFormat;
	fn_lockSurface lockSurface;
	fn_unlockSurface unlockSurface;
	fn_showSurface showSurface;
} sqSurfaceDispatch; 
!

!SQSurfaceDispatch classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/30/2011 12:30'!
fieldsDesc

"
A structure from SurfacePlugin.h 
 

typedef struct sqSurfaceDispatch {
	/* Version information. Must be provided by the client
	   so the surface manager can check if certain operations
	   are supported. */
	int majorVersion;
	int minorVersion;

	/* Version 1.0 */
	fn_getSurfaceFormat getSurfaceFormat;
	fn_lockSurface lockSurface;
	fn_unlockSurface unlockSurface;
	fn_showSurface showSurface;
} sqSurfaceDispatch; 
"
	^ #(
		int majorVersion;
		int minorVersion;
		void* getSurfaceFormatFn;
		void* lockSurfaceFn;
		void* unlockSurfaceFn;
		void* showSurfaceFn
	)! !

!SQSurfaceDispatch methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/30/2011 12:35'!
initialize
	self
		majorVersion: 1; 
		minorVersion: 0! !

AthensPaint subclass: #AthensCairoSolidPaint
	uses: TCairoPaint
	instanceVariableNames: 'color preserve'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo'!

AthensCairoSolidPaint class
	uses: TCairoPaint classTrait
	instanceVariableNames: ''!

!AthensCairoSolidPaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/12/2012 22:54'!
asStrokePaint
	^ AthensCairoStrokePaint new fillPaint: self! !

!AthensCairoSolidPaint methodsFor: 'accessing' stamp: 'IgorStasenko 12/20/2011 15:32'!
color: aColor
	color := aColor! !

!AthensCairoSolidPaint methodsFor: 'drawing' stamp: 'IgorStasenko 3/7/2012 16:49'!
fillPath: path on: anAthensCanvas 

	anAthensCanvas
		setSourceR: color red g: color green b: color blue a: color alpha.
		
	path loadIn: anAthensCanvas.
	
	anAthensCanvas fill.
		
! !

!AthensCairoSolidPaint methodsFor: 'drawing' stamp: 'IgorStasenko 12/20/2011 16:09'!
fillRectangle: aRect on: anAthensCanvas
	"This is a terminal method in rendering dispatch scheme
	canvas->shape->paint. See AthensCanvas>>fillShape: "
	
	
	anAthensCanvas
		setSourceR: color red g: color green b: color blue a: color alpha;
		rectangleX: aRect left y: aRect top width: aRect width height: aRect height;
		fill
	! !

!AthensCairoSolidPaint methodsFor: 'drawing' stamp: 'FernandoOlivero 1/13/2012 10:30'!
loadOn: anAthensCanvas
	anAthensCanvas
		setSourceR: color red
		g: color green
		b: color blue
		a: color alpha.! !

AthensPathBuilder subclass: #AthensCairoPathBuilder
	uses: TCairoLibrary
	instanceVariableNames: 'context absolute endPoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo-Paths'!

AthensCairoPathBuilder class
	uses: TCairoLibrary classTrait
	instanceVariableNames: ''!

!AthensCairoPathBuilder classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/7/2012 14:53'!
buildPathFrom:  aPathCreatingBlock 

	! !

!AthensCairoPathBuilder methodsFor: 'path commands' stamp: 'IgorStasenko 3/7/2012 16:45'!
absolute
	absolute := true! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/8/2012 16:36'!
angleOfVector: v

	| n acos |
	
	n := v normalized.
	acos := n x arcCos.
	
	^ v y < 0 ifTrue: [ Float pi * 2 - acos ] ifFalse: [ acos ]! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/8/2012 16:47'!
arcCenterX: xc centerY: yc radius: radius startAngle: angle1 endAngle: angle2 
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	self nbCall: #(void cairo_arc (AthensCairoCanvas context,
				double xc,
				double yc,
				double radius,
				double angle1,
				double angle2) )
				
			! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/8/2012 17:01'!
arcNegativeCenterX: xc centerY: yc radius: radius startAngle: angle1 endAngle: angle2 
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	self nbCall: #(void cairo_arc_negative (AthensCairoCanvas context,
				double xc,
				double yc,
				double radius,
				double angle1,
				double angle2) )
				
			! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/8/2012 17:12'!
arcTo: newEndPoint angle: angle cw: aBool

	" Add a clockwise arc segment, starting from current path endpoint and
	ending at andPt. Angle should be specified in radians 
	"

	| start end center v radius startAngle endAngle cwAngle |	
	start := endPoint.
	endPoint := end := self toAbsolute: newEndPoint.

	"we have to transform the input. because Cario expects 
	the center , radius, starting and ending angle,
	and we have the starting point, the ending point , and the angle.
	"
	aBool ifTrue: [cwAngle := angle] ifFalse: [cwAngle := angle negated].
	center := self calcCenter: start end: end  angle: cwAngle.
	v := (start - center).
	radius := v r.
	startAngle := self angleOfVector: v.
	endAngle := self angleOfVector: (end-center).
	aBool ifTrue: [ self arcCenterX: center x centerY: center y  radius: radius  startAngle: startAngle endAngle: endAngle ]
		ifFalse: [ self arcNegativeCenterX: center x centerY: center y  radius: radius  startAngle: startAngle  endAngle: endAngle ]
		! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/8/2012 16:54'!
calcCenter: start end: end angle: angle

	| v  rot  center radius len sina cosa m |	

	v := end - start.
	
	m := AthensAffineTransform new rotateByRadians: (Float pi - angle   /2).

	v := m transform: v.		
	len := v r.
	radius := len / 2 / (angle /2) sin.
	
	center := v * (radius/len) + start.

	^ center! !

!AthensCairoPathBuilder methodsFor: 'path commands' stamp: 'IgorStasenko 3/8/2012 17:06'!
ccwArcTo: newEndPoint angle: angle
	" Add a counter-clockwise arc segment, starting from current path endpoint and
	ending at andPt. Angle should be specified in radians 
	"
	^ self arcTo: newEndPoint angle: angle cw: false! !

!AthensCairoPathBuilder methodsFor: 'path commands' stamp: 'IgorStasenko 3/7/2012 16:44'!
close

	self primClose.
	
	endPoint := self getCurrentPoint! !

!AthensCairoPathBuilder methodsFor: 'accessing' stamp: 'IgorStasenko 3/7/2012 15:15'!
context: anObject

	context := anObject! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/7/2012 16:47'!
copyPath 


	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #( AthensCairoPath cairo_copy_path (AthensCairoCanvas context) )
! !

!AthensCairoPathBuilder methodsFor: 'accessing' stamp: 'IgorStasenko 3/7/2012 17:15'!
createPath: aBlock
	
	self newPath.
	"set default to relative"
	absolute := false.
	endPoint := ZeroPoint.
	
	"set the implicit path origin"
	self moveToX: 0 Y: 0.
		
	aBlock value: self.
	
	^ self copyPath initialize ! !

!AthensCairoPathBuilder methodsFor: 'path commands' stamp: 'IgorStasenko 3/7/2012 17:45'!
curveVia: p1 to: aPoint
	| pt0 pt1 cp1 cp2 twoThirds |
	"Quad bezier curve"

	pt0 := endPoint.
	pt1 := self toAbsolute: p1.
	endPoint := self toAbsolute: aPoint.

"Any quadratic spline can be expressed as a cubic (where the cubic term is zero). The end points of the cubic will be the same as the quadratic's.

	CP0 = QP0
	CP3 = QP2

The two control points for the cubic are:

	CP1 = QP0 + 2/3 *(QP1-QP0)
	CP2 = QP2 + 2/3 *(QP1-QP2)"

	twoThirds := (2/3) asFloat.

	cp1 := pt1 - pt0 * twoThirds + pt0.
	cp2 := pt1 - endPoint * twoThirds + endPoint.
	
	self curveViaX: cp1 x Y: cp1 y viaX: cp2 x Y: cp2 y toX: endPoint x Y: endPoint y
! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/7/2012 17:39'!
curveViaX: x1 Y: y1 viaX: x2 Y: y2 toX: x3 Y: y3
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #(void cairo_curve_to(AthensCairoCanvas context,
                                                         double x1,
                                                         double y1,
                                                         double x2,
                                                         double y2,
                                                         double x3,
                                                         double y3))

! !

!AthensCairoPathBuilder methodsFor: 'path commands' stamp: 'IgorStasenko 3/8/2012 17:05'!
cwArcTo: newEndPoint angle: angle
	" Add a clockwise arc segment, starting from current path endpoint and
	ending at andPt. Angle should be specified in radians 
	"
	^ self arcTo: newEndPoint angle: angle cw: true! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/7/2012 16:43'!
getCurrentPoint
	| bx by |
	bx := ByteArray new: (NBExternalType sizeOf: 'double').
	by := bx copy.

	self getCurrentPoint: bx y: by.
	
	^ (bx nbDoubleAt: 1 ) @ (by nbDoubleAt: 1)! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/7/2012 16:30'!
getCurrentPoint: bx y: by
	" move command always starts a new contour "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #(void cairo_move_to (AthensCairoCanvas context,
		 double * bx, double * by ) )
! !

!AthensCairoPathBuilder methodsFor: 'path commands' stamp: 'IgorStasenko 3/7/2012 16:21'!
lineTo: aPoint

	endPoint := self toAbsolute: aPoint.
	^ self lineToX: endPoint x Y: endPoint y! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/7/2012 16:08'!
lineToX: x Y: y

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #(void cairo_line_to (AthensCairoCanvas context,
		 double x, double y ) )
! !

!AthensCairoPathBuilder methodsFor: 'path commands' stamp: 'IgorStasenko 3/7/2012 16:45'!
moveTo: aPoint
	
	endPoint := self toAbsolute: aPoint.
	
	^ self moveToX: endPoint x Y: endPoint y! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/7/2012 16:07'!
moveToX: x Y: y
	" move command always starts a new contour "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #(void cairo_move_to (AthensCairoCanvas context,
		 double x, double y ) )
! !

!AthensCairoPathBuilder methodsFor: 'private' stamp: 'IgorStasenko 3/7/2012 16:04'!
newPath
 
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #( void cairo_new_path ( AthensCairoCanvas context ) )! !

!AthensCairoPathBuilder methodsFor: 'path commands' stamp: 'IgorStasenko 3/7/2012 16:45'!
relative
	absolute := false! !

!AthensCairoPathBuilder methodsFor: 'path commands' stamp: 'IgorStasenko 3/7/2012 16:20'!
toAbsolute: aPoint

	^ absolute ifTrue: [ aPoint ] ifFalse: [ endPoint + aPoint ]! !

AthensTransform subclass: #AthensCairoTransform
	uses: TCairoLibrary
	instanceVariableNames: 'canvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo'!

AthensCairoTransform class
	uses: TCairoLibrary classTrait
	instanceVariableNames: ''!

!AthensCairoTransform classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 16:49'!
for: cairoCanvas
	^ self new canvas: cairoCanvas! !

!AthensCairoTransform methodsFor: 'initializing' stamp: 'IgorStasenko 12/20/2011 16:43'!
canvas: aCairoCanvas
	canvas := aCairoCanvas! !

!AthensCairoTransform methodsFor: 'primitives' stamp: 'IgorStasenko 12/20/2011 16:47'!
loadIdentity

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		void cairo_identity_matrix (AthensCairoCanvas canvas) )

! !

!AthensCairoTransform methodsFor: 'transformations' stamp: 'FernandoOlivero 1/15/2012 19:39'!
moveTo: aPoint
	self moveToX: aPoint x asFloat Y: aPoint y asFloat! !

!AthensCairoTransform methodsFor: 'primitives' stamp: 'FernandoOlivero 1/14/2012 20:31'!
moveToX: px Y: py

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		void cairo_move_to (AthensCairoCanvas canvas,
                                                         double px,
                                                         double py))

! !

!AthensCairoTransform methodsFor: 'primitives' stamp: 'IgorStasenko 12/21/2011 13:43'!
primTransformX: x Y: y

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		void cairo_user_to_device (AthensCairoCanvas canvas,
                                                         NBFloatPtr x,
                                                         NBFloatPtr y) )
! !

!AthensCairoTransform methodsFor: 'primitives' stamp: 'FernandoOlivero 1/14/2012 00:32'!
restore
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_restore(AthensCairoCanvas canvas))
! !

!AthensCairoTransform methodsFor: 'transformations' stamp: 'IgorStasenko 3/7/2012 13:55'!
restoreAfter: aBlock
	self save.
	aBlock ensure:  [ self restore ].! !

!AthensCairoTransform methodsFor: 'transformations' stamp: 'IgorStasenko 12/20/2011 16:45'!
rotateByDegrees: angle

	^ self rotateByRadians: angle degreesToRadians! !

!AthensCairoTransform methodsFor: 'primitives' stamp: 'IgorStasenko 12/20/2011 16:45'!
rotateByRadians: angle

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		void cairo_rotate (AthensCairoCanvas canvas,
                                                         double angle))

! !

!AthensCairoTransform methodsFor: 'primitives' stamp: 'FernandoOlivero 1/14/2012 00:32'!
save
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_save (AthensCairoCanvas canvas))
! !

!AthensCairoTransform methodsFor: 'transformations' stamp: 'FernandoOlivero 1/15/2012 16:49'!
scaleBy: aScalarOrPoint
	| double |
	aScalarOrPoint isPoint
		ifTrue:[
			self
				scaleX: aScalarOrPoint x asFloat
				Y: aScalarOrPoint y asFloat ]
		ifFalse:[ 
			double := aScalarOrPoint asFloat.
			self scaleX: double Y: double ].
! !

!AthensCairoTransform methodsFor: 'primitives' stamp: 'IgorStasenko 12/20/2011 16:44'!
scaleX: fx Y: fy

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		void cairo_scale (AthensCairoCanvas canvas,
                                                         double fx,
                                                         double fy))

! !

!AthensCairoTransform methodsFor: 'vector-transform' stamp: 'IgorStasenko 12/21/2011 13:42'!
transform: aPoint
	| x y |
	"since we use pointers to floats we must create a copy of original values to not scratch them"
	x := aPoint x asFloat shallowCopy.
	y := aPoint y asFloat shallowCopy.
	
	self primTransformX: x Y: y.
	^ x @ y! !

!AthensCairoTransform methodsFor: 'transformations' stamp: 'FernandoOlivero 1/14/2012 00:38'!
translateBy: aPoint
	self translateX: aPoint x Y: aPoint y
! !

!AthensCairoTransform methodsFor: 'primitives' stamp: 'IgorStasenko 12/20/2011 16:54'!
translateX: px Y: py

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		void cairo_translate (AthensCairoCanvas canvas,
                                                         double px,
                                                         double py))

! !

AthensCanvas subclass: #AthensCairoCanvas
	instanceVariableNames: 'handle pathTransform'
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs'
	category: 'Athens-Cairo'!

!AthensCairoCanvas commentStamp: 'IgorStasenko 12/20/2011 15:58' prior: 0!
my instances representing a low-level cairo context and mapped to cairo_t * C type!

!AthensCairoCanvas classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:45'!
asNBExternalType: gen
	"use handle ivar to hold my instance (cairo_t)"
	^ NBExternalObjectType objectClass: self! !

!AthensCairoCanvas classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 16:12'!
nbLibraryNameOrHandle
	^ AthensCairoSurface nbLibraryNameOrHandle! !

!AthensCairoCanvas classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 16:14'!
on: cairoSurface

	^ (self primCreate: cairoSurface) surface: cairoSurface! !

!AthensCairoCanvas classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 16:14'!
primCreate: cairoSurface

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #( 
		AthensCairoCanvas cairo_create (AthensCairoSurface cairoSurface) )! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'FernandoOlivero 1/12/2012 12:20'!
clip
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_clip (self))
! !

!AthensCairoCanvas methodsFor: 'drawing' stamp: 'FernandoOlivero 1/17/2012 11:22'!
clipBy: aRectangle during: aBlock
	self
		rectangleX: aRectangle origin x
		y: aRectangle origin y
		width: aRectangle width
		height: aRectangle height;
		clip.
	aBlock ensure: [ self resetClip ]! !

!AthensCairoCanvas methodsFor: 'paths' stamp: 'FernandoOlivero 1/11/2012 17:10'!
closePath
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self nbCall: #(void cairo_close_path (self) )
! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 12/20/2011 15:56'!
destroy

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #( 	void cairo_destroy (self) )! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 12/20/2011 16:10'!
fill
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_fill (self))
! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'FernandoOlivero 1/11/2012 17:02'!
fillPreserve
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_fill_preserve (self))
! !

!AthensCairoCanvas methodsFor: 'paths' stamp: 'IgorStasenko 3/8/2012 17:32'!
loadPath: aPath

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	 
	^ self nbCall: #( void cairo_append_path (self , AthensCairoPath aPath))
! !

!AthensCairoCanvas methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 16:11'!
nbLibraryNameOrHandle
	^ self class nbLibraryNameOrHandle
! !

!AthensCairoCanvas methodsFor: 'accessing' stamp: 'IgorStasenko 12/20/2011 16:48'!
pathTransform
	^ pathTransform! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 12/20/2011 16:05'!
rectangleX: x y: y width: aWidth height: aHeight
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_rectangle (self,
		 double x, double y,
		 double aWidth, double aHeight) )
! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'FernandoOlivero 1/17/2012 11:22'!
resetClip
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_reset_clip (self))
! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'FernandoOlivero 1/12/2012 13:27'!
setOperator: aCairoOperatorT
	"http://cairographics.org/operators/"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self nbCall: #(void cairo_set_operator (self, cairo_operator_t aCairoOperatorT) )
! !

!AthensCairoCanvas methodsFor: 'private' stamp: 'IgorStasenko 12/20/2011 16:17'!
setSourceR: red g: green b: blue a: alpha

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( 
		void cairo_set_source_rgba ( self ,
			double red,
			double green,
			double blue,
			double alpha) )! !

!AthensCairoCanvas methodsFor: 'accessing' stamp: 'IgorStasenko 12/20/2011 16:49'!
surface: aCairoSurface
	
	"initialize for given surface"
	surface := aCairoSurface.
	
	pathTransform := AthensCairoTransform for: self! !

!AthensCairoCanvas methodsFor: 'path segments visitor' stamp: 'FernandoOlivero 1/15/2012 14:58'!
visitCloseSegment: closeSegment
	self closePath! !

!AthensCairoCanvas methodsFor: 'path segments visitor' stamp: 'FernandoOlivero 2/14/2012 08:16'!
visitCubicSegment: anAthensCubicSegment
	|  destination controlPoint controlPoint2 |
	destination := anAthensCubicSegment to.
	controlPoint := anAthensCubicSegment via1.
	controlPoint2 := anAthensCubicSegment via2.
	self
		curveToX: destination x Y: destination y
		viaX: controlPoint x Y: controlPoint y
		andX: controlPoint2 x Y: controlPoint2 y
		 		
! !

!AthensCairoCanvas methodsFor: 'path segments visitor' stamp: 'IgorStasenko 12/20/2011 18:49'!
visitLineSegment: line

	^ self lineToX: line endPoint x Y: line endPoint y! !

!AthensCairoCanvas methodsFor: 'path segments visitor' stamp: 'IgorStasenko 12/20/2011 18:46'!
visitMoveSegment: mov 
	^ self moveToX: mov endPoint x Y: mov endPoint y! !

!AthensCairoCanvas methodsFor: 'path segments visitor' stamp: 'FernandoOlivero 2/14/2012 08:17'!
visitQuadSegment: anAthensCubicSegment
	| destination controlPoint |
	destination := anAthensCubicSegment to.
	controlPoint := anAthensCubicSegment via.
	self
		curveToX: destination x Y: destination y
		viaX: controlPoint x Y: controlPoint y
		 ! !

AthensStrokePaint subclass: #AthensCairoStrokePaint
	uses: TCairoLibrary
	instanceVariableNames: 'dashes'
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs'
	category: 'Athens-Cairo'!

AthensCairoStrokePaint class
	uses: TCairoLibrary classTrait
	instanceVariableNames: ''!

!AthensCairoStrokePaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/12/2012 22:28'!
beBevel
	self joinStyle: CAIRO_LINE_JOIN_BEVEL! !

!AthensCairoStrokePaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/12/2012 22:45'!
beButt
	self capStyle: CAIRO_LINE_CAP_BUTT.! !

!AthensCairoStrokePaint methodsFor: 'accessing' stamp: 'FernandoOlivero 2/14/2012 12:02'!
beCapRound
	self capStyle: CAIRO_LINE_CAP_ROUND! !

!AthensCairoStrokePaint methodsFor: 'accessing' stamp: 'FernandoOlivero 2/14/2012 12:01'!
beJoinRound
	self joinStyle: CAIRO_LINE_JOIN_ROUND ! !

!AthensCairoStrokePaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/12/2012 22:29'!
beMiter
	self joinStyle: CAIRO_LINE_JOIN_MITER! !

!AthensCairoStrokePaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/12/2012 22:45'!
beSquare
	self capStyle: CAIRO_LINE_CAP_SQUARE! !

!AthensCairoStrokePaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/12/2012 23:47'!
dashes
	^ dashes! !

!AthensCairoStrokePaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/12/2012 23:44'!
dashes: anAlternateCollectionOfLenghts offset: anOffset
	dashes := {anAlternateCollectionOfLenghts. anOffset asFloat}.! !

!AthensCairoStrokePaint methodsFor: 'drawing' stamp: 'IgorStasenko 3/8/2012 16:50'!
fillPath: aPath on: anAthensCanvas
	self loadOn: anAthensCanvas.

	aPath loadIn: anAthensCanvas.

	self strokeOn: anAthensCanvas.
	! !

!AthensCairoStrokePaint methodsFor: 'drawing' stamp: 'FernandoOlivero 1/13/2012 00:32'!
fillRectangle: aRect on: aCanvas
	self fillPaint loadOn: aCanvas.
	self loadOn: aCanvas.
	aCanvas
		rectangleX: aRect left
		y: aRect top
		width: aRect
		width height: aRect height.
	self strokeOn: aCanvas.
! !

!AthensCairoStrokePaint methodsFor: 'initialize-release' stamp: 'IgorStasenko 3/8/2012 17:24'!
initialize
	super initialize.

	width := 1.
	capStyle := joinStyle := nil.
! !

!AthensCairoStrokePaint methodsFor: 'drawing' stamp: 'FernandoOlivero 1/13/2012 20:01'!
loadOn: aCanvas
	self fillPaint loadOn: aCanvas.
	self width notNil ifTrue:[ self primSetLineWidthOn: aCanvas].
	self joinStyle notNil ifTrue:[ self primSetLineJoinOn: aCanvas].
	self capStyle notNil ifTrue:[ self primSetLineCapOn: aCanvas].
	self dashes notNil ifTrue:[ self setDashesOn: aCanvas lengths: self dashes first offset: self dashes second ].! !

!AthensCairoStrokePaint methodsFor: 'private' stamp: 'FernandoOlivero 1/12/2012 23:51'!
primSetDashesOn: aCanvas lengths: dashesLengths count: dashesCount offset: anOffset
"	void                cairo_set_dash                      (cairo_t *cr,
                                                         double *dashes,
                                                         int num_dashes,
                                                         double offset);"
<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self nbCall: #(void cairo_set_dash (
				AthensCairoCanvas aCanvas,
				double* dashesLengths,
				int dashesCount,
				double anOffset) )
! !

!AthensCairoStrokePaint methodsFor: 'private' stamp: 'FernandoOlivero 1/12/2012 23:20'!
primSetLineCapOn: aCanvas
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_set_line_cap (
			AthensCairoCanvas aCanvas,
			cairo_line_cap_t capStyle) )! !

!AthensCairoStrokePaint methodsFor: 'private' stamp: 'FernandoOlivero 1/12/2012 23:21'!
primSetLineJoinOn: aCanvas
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self nbCall: #(void cairo_set_line_join (
			AthensCairoCanvas aCanvas,
			cairo_line_join_t joinStyle) )! !

!AthensCairoStrokePaint methodsFor: 'private' stamp: 'FernandoOlivero 1/12/2012 23:19'!
primSetLineWidthOn: aCanvas
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self nbCall: #(void cairo_set_line_width (
				AthensCairoCanvas aCanvas,
				double width) )
! !

!AthensCairoStrokePaint methodsFor: 'private' stamp: 'FernandoOlivero 1/12/2012 23:52'!
setDashesOn: aCanvas lengths: dashesLengths offset: anOffset
	| count size bytes |
	count := dashesLengths size.
	count = 1 ifTrue:[ 
		^ self
			primSetDashesOn: aCanvas
			lengths: dashesLengths first 
			count: 1
			offset: anOffset ].

	bytes := ByteArray new: count * 4.
	size := 1.
	dashesLengths do:[:each|
			bytes nbUlongAt: size put: each.
			size := size + 4 ].
	self
		primSetDashesOn: aCanvas
		lengths: bytes
		count: count
		offset: anOffset! !

!AthensCairoStrokePaint methodsFor: 'private' stamp: 'IgorStasenko 3/8/2012 17:24'!
strokeOn: aCanvas
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	self nbCall: #(void cairo_stroke(AthensCairoCanvas aCanvas))
! !

AthensSurface subclass: #AthensCairoSurface
	instanceVariableNames: 'handle context builder'
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs'
	category: 'Athens-Cairo'!

!AthensCairoSurface commentStamp: 'IgorStasenko 12/20/2011 15:54' prior: 0!
my instance are mapped to cairo_image_surface_t* C type !

!AthensCairoSurface classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 14:49'!
asNBExternalType: gen
	"use handle ivar to hold my instance (cairo_surface_t)"
	^ NBExternalObjectType objectClass: self! !

!AthensCairoSurface classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/7/2012 15:32'!
extent: anExtent
	^ self extent: anExtent format: CAIRO_FORMAT_ARGB32 ! !

!AthensCairoSurface classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/7/2012 15:32'!
extent: anExtent format: aFormat
	^ ( self primImage: aFormat width: anExtent x height: anExtent y ) initialize
! !

!AthensCairoSurface classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/16/2011 11:38'!
nbLibraryNameOrHandle
	^ '/opt/local/lib/libcairo.2.dylib'! !

!AthensCairoSurface classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 1/12/2012 13:02'!
primImage: aFormat width: aWidth height: aHeight
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(AthensCairoSurface cairo_image_surface_create (int aFormat,
                                                         int aWidth,
                                                         int aHeight) )

! !

!AthensCairoSurface classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:01'!
primWidth: aWidth height: aHeight
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #( AthensCairoSurface cairo_image_surface_create (
						CAIRO_FORMAT_ARGB32,
						int aWidth,
						int aHeight) )! !

!AthensCairoSurface classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:02'!
width: aWidth height: aHeight
	^ (self primWidth: aWidth height: aHeight) initialize! !

!AthensCairoSurface methodsFor: 'converting' stamp: 'FernandoOlivero 2/14/2012 10:44'!
asAthensPaintOn: aCanvas
	^ AthensCairoSurfacePaint on: self.
 ! !

!AthensCairoSurface methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:19'!
asForm

	"create a form and copy an image data there"
	
	| form bytesToCopy|
	
	form := Form extent: self extent depth: 32.
	
	bytesToCopy := self stride * self height.
	
	bytesToCopy > (form bits size * 4) ifTrue: [
		self error: 'cannot copy data' ].
	
	NativeBoost memCopy: self getDataPtr to: form bits size: 	bytesToCopy.
		
	^ form

"	(Form extent: 10@10 depth: 32) bits size => 100 "! !

!AthensCairoSurface methodsFor: 'accessing' stamp: 'IgorStasenko 2/6/2012 15:30'!
clear
	"instead of filling, should use #paint: with SOURCE_OVER operator"
	currentCanvas
		setPaint: Color transparent;
		drawShape: (0@0 extent: self extent).
! !

!AthensCairoSurface methodsFor: 'paints' stamp: 'FernandoOlivero 1/13/2012 22:31'!
createCircularGradient: colorRamp
	between: anInnerCenter
	radius: anInnerRadius
	and: anOuterCenter
	radius: anOuterRadius
 
	^AthensCairoPatternPaint	
		radialBetween: anInnerCenter
		extending: anInnerRadius
		and: anOuterCenter
		extending: anOuterRadius
		withColorRamp: colorRamp! !

!AthensCairoSurface methodsFor: 'paints' stamp: 'FernandoOlivero 1/13/2012 21:23'!
createCircularGradient: colorRamp center: aCenter radius: aRadius
	^ self 
		createCircularGradient: colorRamp
		between: 0
		radius: 0
		and: aCenter
		radius: aRadius
 ! !

!AthensCairoSurface methodsFor: 'paints' stamp: 'FernandoOlivero 1/25/2012 00:46'!
createImagePaint: aFileName 
	^ AthensCairoPngPaint fromFileNamed: aFileName asString.
	! !

!AthensCairoSurface methodsFor: 'paints' stamp: 'FernandoOlivero 1/13/2012 21:02'!
createLinearGradient: aColorRamp origin: aStart corner: aStop
	^ AthensCairoPatternPaint createLinearGradient: aColorRamp origin: aStart corner: aStop! !

!AthensCairoSurface methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/7/2012 14:54'!
createPath: aPathCreatingBlock
	^ builder createPath:  aPathCreatingBlock ! !

!AthensCairoSurface methodsFor: 'paints' stamp: 'FernandoOlivero 1/13/2012 20:12'!
createSolidColorPaint: aColor 

	^ AthensCairoSolidPaint new color: aColor! !

!AthensCairoSurface methodsFor: 'private' stamp: 'IgorStasenko 12/20/2011 14:58'!
destroy
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		void cairo_surface_destroy ( self ) )

! !

!AthensCairoSurface methodsFor: 'drawing' stamp: 'IgorStasenko 3/7/2012 15:08'!
drawDuring: aBlock

	"You may draw on receiver only when inside a block and only using provided canvas object.
	This ensures releasing system resources used after finishing drawing"


	currentCanvas ifNotNil: [ self attemptToRecurseDrawing ].
	[
		currentCanvas := context.
		aBlock value: currentCanvas.
	] ensure: [
		currentCanvas := nil.
	].! !

!AthensCairoSurface methodsFor: 'drawing' stamp: 'FernandoOlivero 1/12/2012 12:59'!
drawImage: aFileName
	| surface |
	surface :=  CairoPNGSurface fromPNG: aFileName.
	surface drawImage: aFileName on: currentCanvas.
	surface finalize.
! !

!AthensCairoSurface methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:18'!
extent
	^ self width @ self height! !

!AthensCairoSurface methodsFor: 'finalization' stamp: 'IgorStasenko 3/7/2012 15:11'!
finalize
	handle value = 0 ifFalse: [
		context ifNotNil: [ context destroy. context := nil ].
		self destroy.
		handle value: 0 ].
! !

!AthensCairoSurface methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:19'!
getDataPtr
	"get a pointer to surface bitmap data"
	
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		void* cairo_image_surface_get_data ( self ) )

! !

!AthensCairoSurface methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:12'!
height
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		int cairo_image_surface_get_height ( self ) )

! !

!AthensCairoSurface methodsFor: 'initialize-release' stamp: 'IgorStasenko 3/7/2012 15:12'!
initialize
	
	handle value = 0 ifTrue: [ 
		self error: 'Error creating new surface' ].
	
	context := self newCanvas.
	builder := AthensCairoPathBuilder new.
	builder context: context.
	
	"register to be finalized"
	WeakRegistry default add: self! !

!AthensCairoSurface methodsFor: 'testing' stamp: 'FernandoOlivero 1/12/2012 11:59'!
isSuccess
	^ self status  =	CAIRO_STATUS_SUCCESS! !

!AthensCairoSurface methodsFor: 'nb helper' stamp: 'IgorStasenko 12/16/2011 11:38'!
nbLibraryNameOrHandle
	^ self class nbLibraryNameOrHandle
! !

!AthensCairoSurface methodsFor: 'private' stamp: 'IgorStasenko 12/20/2011 15:43'!
newCanvas
	"Answer a preinitialized instance of AthensCanvas.
	Private to receiver and its subclasses, override seldom"
	^ AthensCairoCanvas on: self
! !

!AthensCairoSurface methodsFor: 'accessing' stamp: 'FernandoOlivero 1/12/2012 11:55'!
status

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(int cairo_surface_status (self) )
	! !

!AthensCairoSurface methodsFor: 'private' stamp: 'FernandoOlivero 1/12/2012 12:00'!
statusToString: aCairoStatusT
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(String   cairo_status_to_string  (cairo_status_t aCairoStatusT))! !

!AthensCairoSurface methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:10'!
stride
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		int cairo_image_surface_get_stride ( self ) )

! !

!AthensCairoSurface methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 15:12'!
width
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		int cairo_image_surface_get_width ( self ) )

! !

!AthensCairoSurface methodsFor: 'converting' stamp: 'FernandoOlivero 1/12/2012 12:54'!
writeToPng: aFileName
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self nbCall: #(void cairo_surface_write_to_png (self, String aFileName) )
! !

NBExternalObject subclass: #AthensCairoPaint
	uses: TCairoLibrary + TCairoPaint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs'
	category: 'Athens-Cairo'!

AthensCairoPaint class
	uses: TCairoLibrary classTrait + TCairoPaint classTrait
	instanceVariableNames: ''!

!AthensCairoPaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/25/2012 00:13'!
asAthensPaintOn: anAthensCanvas	
	^ self! !

!AthensCairoPaint methodsFor: 'initialize-release' stamp: 'FernandoOlivero 1/25/2012 00:37'!
finalize
	handle value = 0 ifFalse: [
		self destroy.
		handle value: 0
		 ].
! !

!AthensCairoPaint methodsFor: 'testing' stamp: 'FernandoOlivero 1/13/2012 21:51'!
isSuccess
	^ self status  =	CAIRO_STATUS_SUCCESS! !

AthensCairoPaint subclass: #AthensCairoPatternPaint
	instanceVariableNames: 'bounds orientation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo'!

!AthensCairoPatternPaint classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 1/13/2012 21:58'!
createLinearGradient: aColorRamp origin: aStart corner: aStop
	| paint |
	paint := self
		primCreateLinearXo: aStart x asFloat
		yo: aStart y asFloat
		x1: aStop x asFloat
		y1: aStop y asFloat.
	paint initializeLinearFrom: aStart to: aStop withColorRamp: aColorRamp.
	^ paint! !

!AthensCairoPatternPaint classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 1/13/2012 21:46'!
primCreateLinearXo: xo yo: yo x1: x1 y1: y1
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(cairo_pattern_t cairo_pattern_create_linear (
		double xo,
		double yo,
		double x1,
		double y1 ) )
! !

!AthensCairoPatternPaint classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 2/24/2012 19:38'!
primCreateRadialXo: xo yo: yo radiuso: radiuso x1: x1 y1: y1 radius1: radius1
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(cairo_pattern_t cairo_pattern_create_radial (
		double xo,
		double yo,
		double radiuso,
		double x1,
		double y1,
		double radius1 ) )
! !

!AthensCairoPatternPaint classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 1/13/2012 22:31'!
radialBetween: origin
	extending: innerRadius
	and: outerOrigin
	extending: outerRadius
	withColorRamp: colorRamp
	| paint |

	paint := self
		primCreateRadialXo: origin x 
		yo: origin y 
		radiuso: innerRadius 
		x1: outerOrigin x
		y1: outerOrigin y 
		radius1: outerRadius.
	paint
		initializeRadialBetween: origin
			extending: innerRadius
			and: outerOrigin
			extending: outerRadius
			withColorRamp: colorRamp.
	^ paint.! !

!AthensCairoPatternPaint methodsFor: 'initialize-release' stamp: 'FernandoOlivero 1/13/2012 22:44'!
addColorStopAt: anOffset colored: aColor
	| r g b a |
	a := 0.
	aColor isColor
		ifTrue:[
			r := aColor red.
			g := aColor green.
			b := aColor blue.
			a := aColor alpha]
		ifFalse:[
			r := aColor first.
			g := aColor second.
			b := aColor third.
			aColor size > 3 ifTrue:[ a := aColor fourth ]].
	a > 0
		ifTrue: [ self primAddColorStopOffset: anOffset R: r G: g B: b A: a]
		ifFalse: [ self primAddColorStopOffset: anOffset R: r G: g B: b ].! !

!AthensCairoPatternPaint methodsFor: 'converting' stamp: 'FernandoOlivero 1/15/2012 02:59'!
asStrokePaint
	^ AthensCairoStrokePaint new fillPaint: self! !

!AthensCairoPatternPaint methodsFor: 'initialize-release' stamp: 'FernandoOlivero 1/13/2012 10:48'!
destroy
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self nbCall: #(void cairo_pattern_destroy (self) )
! !

!AthensCairoPatternPaint methodsFor: 'initialize-release' stamp: 'IgorStasenko 3/8/2012 17:37'!
initializeLinearFrom: aStart to: aStop withColorRamp: aRamp
	aRamp do:[:each|
		self
			addColorStopAt: each key
			colored: each value ]
	! !

!AthensCairoPatternPaint methodsFor: 'initialize-release' stamp: 'IgorStasenko 3/8/2012 17:37'!
initializeRadialBetween: origin
			extending: innerRadius
			and: outerOrigin
			extending: outerRadius
			withColorRamp: aRamp
	aRamp do:[:each|
		self
			addColorStopAt: each key
			colored: each value ]
	! !

!AthensCairoPatternPaint methodsFor: 'testing' stamp: 'FernandoOlivero 1/13/2012 20:24'!
isLinear
	^ orientation = #linear.! !

!AthensCairoPatternPaint methodsFor: 'testing' stamp: 'FernandoOlivero 1/13/2012 20:15'!
isPatternTypeMismatch
	^ self status = CAIRO_STATUS_PATTERN_TYPE_MISMATCH.! !

!AthensCairoPatternPaint methodsFor: 'testing' stamp: 'FernandoOlivero 1/13/2012 20:24'!
isRadial
	^ orientation = #radial.! !

!AthensCairoPatternPaint methodsFor: 'drawing' stamp: 'FernandoOlivero 1/13/2012 21:51'!
loadOn: anAthensCanvas 
	self isSuccess
		ifTrue:[ 
			self primSetSourceOn: anAthensCanvas.]
		ifFalse:[
			anAthensCanvas setSourceR: 1.0 g: 0.0 b: 0.0 a: 1.0].
! !

!AthensCairoPatternPaint methodsFor: 'private' stamp: 'FernandoOlivero 1/13/2012 20:15'!
primAddColorStopOffset: offset R: red G: green B: blue 
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall:#(void cairo_pattern_add_color_stop_rgb    (cairo_pattern_t  self,
                                                         double offset,
                                                         double red,
                                                         double green,
                                                         double blue))
		! !

!AthensCairoPatternPaint methodsFor: 'private' stamp: 'FernandoOlivero 1/13/2012 20:15'!
primAddColorStopOffset: offset R: red G: green B: blue A: alpha 
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall:#(void cairo_pattern_add_color_stop_rgba    (cairo_pattern_t  self,
                                                         double offset,
                                                         double red,
                                                         double green,
                                                         double blue,
												double alpha ))
		! !

!AthensCairoPatternPaint methodsFor: 'private' stamp: 'FernandoOlivero 1/13/2012 21:52'!
primSetSourceOn: aCanvas
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_set_source ( cairo_t  aCanvas, cairo_pattern_t  self))
		! !

!AthensCairoPatternPaint methodsFor: 'private' stamp: 'FernandoOlivero 1/13/2012 20:15'!
status
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(int cairo_pattern_status (cairo_pattern_t  self))
		! !

AthensCairoPaint subclass: #AthensCairoPngPaint
	instanceVariableNames: 'fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo'!

!AthensCairoPngPaint classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 1/24/2012 23:22'!
fromFileNamed: aFileName
	|paint|
	paint := self primFromFileNamed: aFileName.
	paint initializeFromFileNamed: aFileName.
	^ paint  ! !

!AthensCairoPngPaint classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 1/25/2012 00:51'!
primFromFileNamed: aFileName

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin> 
	
	^self nbCall: #(AthensCairoPngPaint cairo_image_surface_create_from_png (char * aFileName)) 
! !

!AthensCairoPngPaint methodsFor: 'initialize-release' stamp: 'FernandoOlivero 1/13/2012 18:31'!
destroy
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(void cairo_surface_destroy ( self ) )

! !

!AthensCairoPngPaint methodsFor: 'private' stamp: 'FernandoOlivero 1/13/2012 18:43'!
extent
	^ self primGetWidth @ self primGetHeight! !

!AthensCairoPngPaint methodsFor: 'initialize-release' stamp: 'IgorStasenko 3/8/2012 17:37'!
initializeFromFileNamed: aFileName
	fileName := aFileName .
	! !

!AthensCairoPngPaint methodsFor: 'testing' stamp: 'FernandoOlivero 1/13/2012 11:35'!
isPNGFileNotFound
 	^ self status = CAIRO_STATUS_FILE_NOT_FOUND ! !

!AthensCairoPngPaint methodsFor: 'testing' stamp: 'FernandoOlivero 1/13/2012 11:35'!
isPNGReadError
 	^ self status = CAIRO_STATUS_READ_ERROR ! !

!AthensCairoPngPaint methodsFor: 'filling' stamp: 'FernandoOlivero 1/24/2012 23:23'!
loadOn: anAthensCanvas 
	self loadOn: anAthensCanvas at: 0@0
! !

!AthensCairoPngPaint methodsFor: 'filling' stamp: 'FernandoOlivero 1/25/2012 00:58'!
loadOn: anAthensCanvas at: aPoint 
	| extent |
	self isSuccess
		ifTrue:[ 
			extent :=  self extent.
			self setSourceSurfaceOn: anAthensCanvas at: aPoint]
		ifFalse:[
			extent :=  40@40.
			anAthensCanvas setSourceR: 1.0 g: 0.0 b: 0.0 a: 1.0].
! !

!AthensCairoPngPaint methodsFor: 'private' stamp: 'FernandoOlivero 1/13/2012 18:43'!
primGetHeight
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		int cairo_image_surface_get_height ( self ) )

! !

!AthensCairoPngPaint methodsFor: 'private' stamp: 'FernandoOlivero 1/13/2012 18:43'!
primGetWidth
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(
		int cairo_image_surface_get_width ( self ) )

! !

!AthensCairoPngPaint methodsFor: 'private' stamp: 'FernandoOlivero 1/13/2012 11:35'!
primSetSourceSurfaceOn: anAthensCanvas X: x Y: y
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>

	self nbCall:#(void cairo_set_source_surface (
								 AthensCairoCanvas anAthensCanvas,
                                 self ,
                                 double x,
                                 double y))
	! !

!AthensCairoPngPaint methodsFor: 'private' stamp: 'FernandoOlivero 1/13/2012 11:34'!
setSourceSurfaceOn: anAthensCanvas at: aPoint
	self primSetSourceSurfaceOn: anAthensCanvas X: aPoint x Y: aPoint y! !

!AthensCairoPngPaint methodsFor: 'private' stamp: 'FernandoOlivero 1/13/2012 11:34'!
status

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(int cairo_surface_status (self) )
	! !

!AthensCairoPngPaint methodsFor: 'private' stamp: 'FernandoOlivero 1/25/2012 00:26'!
width
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(int cairo_image_surface_get_width ( self ) )

! !

NBExternalObject subclass: #AthensCairoPath
	uses: TCairoLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo'!

AthensCairoPath class
	uses: TCairoLibrary classTrait
	instanceVariableNames: ''!

!AthensCairoPath methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/7/2012 17:18'!
destroy

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCall: #(void cairo_path_destroy ( self ))
! !

!AthensCairoPath methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/7/2012 17:15'!
finalize
	handle value = 0 ifFalse: [ 
		self destroy.
		handle value: 0 ].
! !

!AthensCairoPath methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/7/2012 17:14'!
initialize 
	handle value = 0 ifTrue: [ 
		self error: 'Error creating new path' ].

	WeakRegistry default add: self! !

!AthensCairoPath methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/8/2012 17:29'!
loadInto: context

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	 
	^ self nbCall: #( void cairo_append_path (AthensCairoCanvas context, self ))
! !

!AthensCairoPath methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/20/2011 18:33'!
paintFillsUsing: aPaint on: anAthensCanvas 
	
	"This method is a part of rendering dispatch  Canvas->receiver->paint"
	
	^ aPaint fillPath: self on: anAthensCanvas! !

Object subclass: #AthensCairoSurfacePaint
	uses: TCairoLibrary
	instanceVariableNames: 'surface'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo'!

AthensCairoSurfacePaint class
	uses: TCairoLibrary classTrait
	instanceVariableNames: ''!

!AthensCairoSurfacePaint classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 1/26/2012 13:54'!
on: anAthensCairoSurface
	| paint |
	paint := self new.
	paint initializeOn: anAthensCairoSurface.
	^ paint ! !

!AthensCairoSurfacePaint methodsFor: 'drawing' stamp: 'FernandoOlivero 1/26/2012 14:09'!
fillRectangle: aRect on: anAthensCanvas
	"This is a terminal method in rendering dispatch scheme
	canvas->shape->paint. See AthensCanvas>>fillShape: "
	self loadOn: anAthensCanvas at: aRect origin.
	anAthensCanvas
		rectangleX: aRect left
		y: aRect top
		width: aRect width
		height: aRect height.
	self paintOn: anAthensCanvas.	
! !

!AthensCairoSurfacePaint methodsFor: 'initialize-release' stamp: 'FernandoOlivero 2/1/2012 13:12'!
initializeOn: anAthensCairoSurface
	surface := anAthensCairoSurface.
	! !

!AthensCairoSurfacePaint methodsFor: 'drawing' stamp: 'FernandoOlivero 2/1/2012 18:49'!
loadOn: anAthensCanvas at: aPoint
	 self primSetSourceSurfaceOn: anAthensCanvas x: aPoint x y: aPoint y ! !

!AthensCairoSurfacePaint methodsFor: 'drawing' stamp: 'FernandoOlivero 2/14/2012 12:30'!
paintOn: aCanvas
	
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #(void cairo_paint (AthensCairoCanvas aCanvas ))
! !

!AthensCairoSurfacePaint methodsFor: 'drawing' stamp: 'FernandoOlivero 2/1/2012 18:50'!
primSetSourceSurfaceOn: aCanvas x: x y: y
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	self nbCall: #( void cairo_set_source_surface (
		AthensCairoCanvas aCanvas,
		AthensCairoSurface  surface,
		double x,
		double y ) )
! !

Object subclass: #AthensCairoText
	uses: TCairoLibrary
	instanceVariableNames: 'text fontFamily fontSlant fontWeight fontSize'
	classVariableNames: ''
	poolDictionaries: 'AthensCairoDefs'
	category: 'Athens-Cairo'!

AthensCairoText class
	uses: TCairoLibrary classTrait
	instanceVariableNames: ''!

!AthensCairoText classSide methodsFor: 'as yet unclassified' stamp: ''!
nbLibraryNameOrHandle
	^ '/opt/local/lib/libcairo.2.dylib'! !

!AthensCairoText methodsFor: 'accessing' stamp: 'FernandoOlivero 1/14/2012 18:35'!
asString
	^ text asString! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 18:23'!
beBold
	self fontWeight: CAIRO_FONT_WEIGHT_BOLD! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 19:40'!
beNormal
	self fontWeight: CAIRO_FONT_WEIGHT_NORMAL! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 18:23'!
beSlantNormal
	self fontSlant: CAIRO_FONT_SLANT_NORMAL! !

!AthensCairoText methodsFor: 'drawing' stamp: 'FernandoOlivero 1/14/2012 18:34'!
drawOn: aCanvas
	self loadOn: aCanvas.
	self showOn: aCanvas! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 18:23'!
fontFamily

	^ fontFamily! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 19:42'!
fontFamily: anObject
	"CSS2 generic family names: serif, sans-serif, cursive, fantasy, monospace"
	fontFamily := anObject! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 18:23'!
fontSize

	^ fontSize! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 18:23'!
fontSize: anObject

	fontSize := anObject! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 18:24'!
fontSlant

	^ fontSlant! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 20:00'!
fontSlant: anObject
	anObject isSymbol
		ifTrue:[ fontSlant := self slantFrom: anObject ]
		ifFalse:[ fontSlant := anObject ]! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 18:24'!
fontWeight

	^ fontWeight! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/25/2012 01:03'!
fontWeight: anObject
	anObject isSymbol
		ifTrue:[ fontWeight := self weightFrom: anObject ]
		ifFalse:[ fontWeight :=  anObject ] ! !

!AthensCairoText methodsFor: 'drawing' stamp: 'FernandoOlivero 1/25/2012 00:59'!
loadOn: aCanvas
	self
		primSelectFont:  fontFamily
			slant:  fontSlant
			weight:  fontWeight 
			on: aCanvas;
		primSetFontSize:  fontSize on: aCanvas.! !

!AthensCairoText methodsFor: 'as yet unclassified' stamp: ''!
nbLibraryNameOrHandle
	^ self class nbLibraryNameOrHandle
! !

!AthensCairoText methodsFor: 'private' stamp: 'FernandoOlivero 1/25/2012 01:00'!
primSelectFont: aFontFamily
		slant: aFontSlant
		weight: aFontWeight 
		on: aCanvas
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	self nbCall: #(void cairo_select_font_face (
			cairo_t aCanvas,
   			char * aFontFamily,
      		cairo_font_slant_t aFontSlant,
        	cairo_font_weight_t aFontWeight) )
	! !

!AthensCairoText methodsFor: 'private' stamp: 'FernandoOlivero 1/14/2012 18:31'!
primSetFontSize: aFontSize on: aCanvas
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	self nbCall: #(void cairo_set_font_size (
			cairo_t aCanvas,
			double aFontSize) )
! !

!AthensCairoText methodsFor: 'private' stamp: 'FernandoOlivero 1/25/2012 00:59'!
primShowText: aString on: aCanvas
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	self nbCall: #(void cairo_show_text (
			cairo_t aCanvas,
			char * aString) )
! !

!AthensCairoText methodsFor: 'font description' stamp: 'FernandoOlivero 1/14/2012 20:10'!
readFrom: aFontDescription
	self fontFamily: aFontDescription fontFamily.
	self fontSlant: aFontDescription fontSlant.
	self fontWeight:  aFontDescription fontWeight.
	self fontSize: aFontDescription fontSize.! !

!AthensCairoText methodsFor: 'drawing' stamp: 'FernandoOlivero 1/14/2012 18:35'!
showOn: aCanvas
	self primShowText: self asString on: aCanvas! !

!AthensCairoText methodsFor: 'private' stamp: 'FernandoOlivero 1/25/2012 01:02'!
slantFrom: aSymbol
	^ aSymbol caseOf: {
		[#normal]->[ CAIRO_FONT_SLANT_NORMAL ].
 		[#italic]->[   CAIRO_FONT_SLANT_ITALIC ].
		[#oblique]->[ CAIRO_FONT_SLANT_OBLIQUE ] }! !

!AthensCairoText methodsFor: 'accessing' stamp: 'FernandoOlivero 1/14/2012 18:24'!
text

	^ text! !

!AthensCairoText methodsFor: 'accessing' stamp: 'FernandoOlivero 1/14/2012 18:24'!
text: anObject

	text := anObject! !

!AthensCairoText methodsFor: 'private' stamp: 'FernandoOlivero 1/25/2012 01:03'!
weightFrom: aSymbol
	^ aSymbol caseOf: {
		[#normal]->[ CAIRO_FONT_WEIGHT_NORMAL  ].
 		[#bold]->[    CAIRO_FONT_WEIGHT_BOLD ] }
! !

Object subclass: #AthensFontDescription
	instanceVariableNames: 'family options size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo'!

!AthensFontDescription commentStamp: 'FernandoOlivero 1/24/2012 18:30' prior: 0!
Creates a new font description from a string representation in the form 
"[FAMILY-LIST] [STYLE-OPTIONS] [SIZE]", 

1)FAMILY-LIST is a comma separated list of families optionally terminated by a comma,

2)STYLE_OPTIONS is a whitespace separated list of words where each WORD describes one of style, variant, weight, stretch, or gravity. If STYLE-OPTIONS is missing, then all style options will be set to the default values

3)SIZE is a decimal number (size in points) or optionally followed by the unit modifier "px" for absolute size. 

!

!AthensFontDescription classSide methodsFor: 'examples' stamp: 'FernandoOlivero 1/24/2012 18:43'!
example
	| fDesc |
	fDesc := AthensFontDescription new. 
	fDesc
		family: 'monospace';
		fontSize: 22.
	^ fDesc! !

!AthensFontDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/17/2012 16:31'!
asString
	"[FAMILY-LIST] [STYLE-OPTIONS] [SIZE]"
	| str |
	str := '' writeStream.
	str nextPutAll:  family; space.
	"	
2)STYLE_OPTIONS is a whitespace separated list of words where each WORD describes one of style, variant, weight, stretch, or gravity. If STYLE-OPTIONS is missing, then all style options will be set to the default values
"
	#(slant. variant. weight. stretch. gravity) do:[:each|
		|val|
		val := options at: each ifAbsent: nil.
		val notNil ifTrue:[str nextPutAll: val ; space ]].
	
	self fontSize notNil ifTrue:[
		str
			space;
			nextPutAll: self fontSize asString ].
	^ str contents! !

!AthensFontDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/14/2012 20:07'!
beBold
	self weight: #bold! !

!AthensFontDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/14/2012 20:06'!
beItalic
	self slant: #italic! !

!AthensFontDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/14/2012 20:07'!
beNormal
	self slant: #normal ; weight: #normal.! !

!AthensFontDescription methodsFor: 'accessing' stamp: 'FernandoOlivero 1/14/2012 20:06'!
beOblique
	self slant: #oblique! !

!AthensFontDescription methodsFor: 'cairo-options' stamp: 'FernandoOlivero 1/14/2012 19:42'!
family: aFamilyName
	"CSS2 generic family names: serif, sans-serif, cursive, fantasy, monospace"
	family := aFamilyName.
	! !

!AthensFontDescription methodsFor: 'cairo-options' stamp: 'FernandoOlivero 1/14/2012 20:10'!
fontFamily
	^ family! !

!AthensFontDescription methodsFor: 'pango-options' stamp: 'FernandoOlivero 1/17/2012 16:26'!
fontGravity
	^ options at: #gravity! !

!AthensFontDescription methodsFor: 'cairo-options' stamp: 'FernandoOlivero 1/14/2012 20:09'!
fontSize
	^ size ! !

!AthensFontDescription methodsFor: 'cairo-options' stamp: 'FernandoOlivero 1/10/2012 12:12'!
fontSize: aPointSize
	size := aPointSize! !

!AthensFontDescription methodsFor: 'cairo-options' stamp: 'FernandoOlivero 1/25/2012 01:02'!
fontSlant
	^ options at: #slant ! !

!AthensFontDescription methodsFor: 'pango-options' stamp: 'FernandoOlivero 1/17/2012 16:26'!
fontStretch
	^ options at: #stretch! !

!AthensFontDescription methodsFor: 'pango-options' stamp: 'FernandoOlivero 1/17/2012 16:25'!
fontVariant
	^ options at: #variant ! !

!AthensFontDescription methodsFor: 'cairo-options' stamp: 'FernandoOlivero 1/14/2012 20:06'!
fontWeight
	^ options at: #weight ! !

!AthensFontDescription methodsFor: 'pango-options' stamp: 'FernandoOlivero 1/17/2012 16:28'!
gravity: aNumber
	options at: #gravity put: aNumber.		
! !

!AthensFontDescription methodsFor: 'initialize-release' stamp: 'FernandoOlivero 1/14/2012 20:08'!
initialize
	super initialize.
	family := 'monospace'.
	options := Dictionary new.
	options
		at:#weight put: #normal; 
		at:#slant put: #normal.
	size := 14.
	! !

!AthensFontDescription methodsFor: 'cairo-options' stamp: 'FernandoOlivero 1/14/2012 19:52'!
slant: aNumber
	options at: #slant put: aNumber.		
! !

!AthensFontDescription methodsFor: 'pango-options' stamp: 'FernandoOlivero 1/17/2012 16:28'!
stretch: aNumber
	options at: #stretch put: aNumber.		
! !

!AthensFontDescription methodsFor: 'pango-options' stamp: 'FernandoOlivero 1/17/2012 16:28'!
variant: aNumber
	options at: #variant put: aNumber.		
! !

!AthensFontDescription methodsFor: 'cairo-options' stamp: 'FernandoOlivero 1/14/2012 19:52'!
weight: aNumber
	options at: #weight put: aNumber.		
! !

Object subclass: #FileImagePaint
	instanceVariableNames: 'fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo'!

!FileImagePaint classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 1/12/2012 12:47'!
fileNamed: aFileName
	| image|
	image := self new.
	image initializeOnFileNamed: aFileName.
	^ image! !

!FileImagePaint methodsFor: 'converting' stamp: 'FernandoOlivero 1/25/2012 00:42'!
asAthensPaintOn: anAthensCanvas
	 ^anAthensCanvas surface createImagePaint: fileName! !

!FileImagePaint methodsFor: 'initialize-release' stamp: 'FernandoOlivero 1/12/2012 12:47'!
initializeOnFileNamed: aFileName
	fileName := aFileName.! !

Object subclass: #PatternPaint
	instanceVariableNames: 'stops colorRamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo'!

PatternPaint subclass: #LinearPaint
	instanceVariableNames: 'start stop'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo'!

!LinearPaint classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 1/13/2012 23:10'!
from: aStart  to: aStop
	| p |
	p := self new.
	p initializeFrom: aStart  to: aStop.
	^ p! !

!LinearPaint methodsFor: 'converting' stamp: 'FernandoOlivero 2/24/2012 19:52'!
asAthensPaintOn: aCanvas
	^ aCanvas surface
			createLinearGradient: self colorRamp
				origin: self start 
				corner: self stop! !

!LinearPaint methodsFor: 'initialize-release' stamp: 'FernandoOlivero 1/13/2012 23:10'!
initializeFrom: aStart  to: aStop
	start := aStart.
	stop := aStop.! !

!LinearPaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/13/2012 23:10'!
start

	^ start! !

!LinearPaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/13/2012 23:10'!
stop

	^ stop! !

!PatternPaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/13/2012 22:45'!
addStopAt: anOffset colored: aColor
	stops add: (anOffset -> aColor).
	colorRamp := stops asArray.! !

!PatternPaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/13/2012 22:45'!
addStopAt: anOffset rgb: anArray
	self addStopAt: anOffset colored: anArray.! !

!PatternPaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/13/2012 22:45'!
addStopAt: anOffset rgba: anArray
	self addStopAt: anOffset colored: anArray.! !

!PatternPaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/13/2012 20:45'!
clear
	stops := OrderedCollection new.! !

!PatternPaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/13/2012 21:11'!
colorRamp
	^ colorRamp! !

!PatternPaint methodsFor: 'initialize-release' stamp: 'FernandoOlivero 1/13/2012 20:33'!
initialize
	super initialize.
	stops := OrderedCollection new.! !

!PatternPaint methodsFor: 'testing' stamp: 'FernandoOlivero 1/13/2012 21:36'!
is: aSymbol
	^ aSymbol = #pattern or:[ super is: aSymbol]
	! !

!PatternPaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/13/2012 20:32'!
stops

	^ stops! !

!PatternPaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/13/2012 21:11'!
stops: anObject

	stops := anObject.
	colorRamp := stops asArray.! !

PatternPaint subclass: #RadialPaint
	instanceVariableNames: 'inner outer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo'!

!RadialPaint classSide methodsFor: 'as yet unclassified' stamp: 'FernandoOlivero 1/13/2012 22:20'!
between: anOrigin extending: innerRadius to: outerPosition extending: outerRadius
	| paint |
	paint := self new.
	paint initializeFrom: anOrigin extending: innerRadius to: outerPosition extending: outerRadius.
	^ paint! !

!RadialPaint methodsFor: 'converting' stamp: 'FernandoOlivero 2/24/2012 19:52'!
asAthensPaintOn: aCanvas
	^ aCanvas surface
		createCircularGradient:  colorRamp
		between:  inner key 
		radius:  inner value 
		and:  outer key
		radius:  outer value! !

!RadialPaint methodsFor: 'converting' stamp: 'FernandoOlivero 2/24/2012 19:32'!
at: aPoint extending: aRadius
	| paint |
	paint := AbsoluteRadialPaint
		between: (inner key * aRadius + aPoint) 
		extending: inner value * aRadius 
		to: (outer key * aRadius + aPoint) 
		extending: outer value * aRadius
		withColorRamp: colorRamp.
	^ paint! !

!RadialPaint methodsFor: 'initialize-release' stamp: 'FernandoOlivero 1/13/2012 21:25'!
initializeFrom: anOrigin extending: innerRadius to: outerPosition extending: outerRadius
	inner :=  anOrigin ->  innerRadius.
	outer := outerPosition ->  outerRadius.! !

!RadialPaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/13/2012 20:40'!
inner

	^ inner! !

!RadialPaint methodsFor: 'accessing' stamp: 'FernandoOlivero 1/13/2012 20:40'!
outer

	^ outer! !

Object subclass: #SurfaceManager
	uses: TCairoLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Cairo'!

SurfaceManager class
	uses: TCairoLibrary classTrait
	instanceVariableNames: 'uniqueSession dispatch'!

!SurfaceManager commentStamp: 'IgorStasenko 12/30/2011 12:41' prior: 0!
/* The following are the entry points for the surface manager:

	int ioRegisterSurface(int surfaceHandle, sqSurfaceDispatch *fn, int *surfaceID);
		Register a new surface with the given handle and
		the set of surface functions. The new ID is returned
		in surfaceID. Returns true if successful, false 
		otherwise.

	int ioUnregisterSurface(int surfaceID);
		Unregister the surface with the given handle.
		Returns true if successful, false otherwise.

	int ioFindSurface(int surfaceID, sqSurfaceDispatch *fn, int *surfaceHandle);
		Find the surface with the given ID, and, optionally,
		the given set of surface functions. The registered handle
		is returned in surfaceHandle. Return true if successful
		(e.g., the surface has been found), false otherwise.

	The above entry points can be looked up through the interpreter, e.g., using
		interpreterProxy->ioLoadFunctionFrom("ioRegisterSurface","SurfacePlugin");
	The typedefs below are for easier casts.
*/
typedef int (*fn_ioRegisterSurface)(int surfaceHandle, sqSurfaceDispatch *fn, int *surfaceID);
typedef int (*fn_ioUnregisterSurface)(int surfaceID);
typedef int (*fn_ioFindSurface)(int surfaceID, sqSurfaceDispatch *fn, int *surfaceHandle);

!

SurfaceManager class
	uses: TCairoLibrary classTrait
	instanceVariableNames: 'uniqueSession dispatch'!

!SurfaceManager classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 1/11/2012 15:23'!
checkSession
	uniqueSession == NativeBoost uniqueSessionObject ifFalse: [
		self initializeForNewSession
	].! !

!SurfaceManager classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 1/17/2012 18:44'!
createGetSurfaceFormatFn

	"
		int getSurfaceFormat(int handle, int* width, int* height, int* depth, int* isMSB);

		Return general information about the OS drawing surface.
		Return true if successful, false otherwise.

		The returned values describe the basic properties such as
		width, height, depth and LSB vs. MSB pixels.
	"

	| fn |

	fn := NBNativeFunctionGen 
		cdecl: #( int (int handle, int* width, int* height, int* depth, int* isMSB) )
		emit: [:gen :proxy :asm | | callInfo fnPtr |

			" the handle is a handle to cairo image surface (cairo_surface_t *) "

			"*width = cairo_image_surface_get_width ( handle )"
			asm cdeclCall: [:call |
				call push: (gen arg: #handle).
				asm
					mov: (self fnPtr: 'cairo_image_surface_get_width') asUImm32 to: asm EAX;
					call: asm EAX
			] alignment: gen stackAlignment;
			
			mov: (gen arg: #width) to: asm EDX;
			mov: asm EAX to: asm EDX ptr.
		
			"*height = cairo_image_surface_get_height ( handle )"
			asm cdeclCall: [:call |
				call push: (gen arg: #handle).
				asm
					mov: (self fnPtr: 'cairo_image_surface_get_height') asUImm32 to: asm EAX;
					call: asm EAX
			] alignment: gen stackAlignment;

			mov: (gen arg: #height) to: asm EDX;
			mov: asm EAX to: asm EDX ptr.

			"*depth = 32"
			asm 
				mov: (gen arg: #depth) to: asm EAX;
				mov: 32 to: asm EAX ptr.
			
			" *isMSB = false "
			asm 
				mov: (gen arg: #isMSB) to: asm EAX;
				mov: 0 to: asm EAX ptr;

			"return true"
				mov: 1 to: asm EAX
						
		].
	
! !

!SurfaceManager classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 1/17/2012 15:14'!
fnPtr: anFnName

	^ NativeBoost loadSymbol: anFnName fromModule: self nbLibraryNameOrHandle.

! !

!SurfaceManager classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 1/11/2012 15:27'!
initializeForNewSession
	uniqueSession := NativeBoost uniqueSessionObject.
	
	"create a dispatch structure"
	dispatch := SQSurfaceDispatch new.
	
	dispatch 
		getSurfaceFormatFn: self createGetSurfaceFormatFn;
		lockSurfaceFn: self createLockSurfaceFn;
		unlockSurfaceFn: self createLockSurfaceFn;
		showSurfaceFn: self createShowSurfaceFn! !

!SurfaceManager classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/30/2011 12:57'!
ioRegisterSurface: handle dispatch: sqSurfaceDispatch

"
	int ioRegisterSurface(int surfaceHandle, sqSurfaceDispatch *fn, int *surfaceID);

	Register a new surface with the given handle and
	the set of surface functions. The new ID is returned
	in surfaceID. Returns true if successful, false 
	otherwise.

"
	| id |
	id := ByteArray new: (NBExternalType sizeOf: #int).

	self ioRegisterSurface: 0 dispatch: sqSurfaceDispatch surfaceId: id.
	
	id := id nbLongAt: 1.
! !

!SurfaceManager classSide methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 1/17/2012 16:53'!
ioRegisterSurface: surfaceHandle dispatch: sqSurfaceDispatchPtr surfaceId: idHolder
"
	int ioRegisterSurface(int surfaceHandle, sqSurfaceDispatch *fn, int *surfaceID);

	Register a new surface with the given handle and
	the set of surface functions. The new ID is returned
	in surfaceID. Returns true if successful, false 
	otherwise.

"

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
"NativeBoost forCurrentPlatform ioLoadFunction: 'ioRegisterSurface' from: 'SurfacePlugin' "
	^ self nbCall: #(	bool ioRegisterSurface(int surfaceHandle, void * fn, int *surfaceID) ) module: #SurfacePlugin! !
